org.codehaus.groovy.transform

## Class AbstractASTTransformUtil

- java.lang.Object
- - org.codehaus.groovy.transform.AbstractASTTransformUtil

All Implemented Interfaces:
  org.objectweb.asm.Opcodes

    public abstract class AbstractASTTransformUtil
    extends java.lang.Object
    implements org.objectweb.asm.Opcodes

### Field Summary

### Fields inherited from interface org.objectweb.asm.Opcodes

`AALOAD, AASTORE, ACC_ABSTRACT, ACC_ANNOTATION, ACC_BRIDGE, ACC_DEPRECATED, ACC_ENUM, ACC_FINAL, ACC_INTERFACE, ACC_NATIVE, ACC_PRIVATE, ACC_PROTECTED, ACC_PUBLIC, ACC_STATIC, ACC_STRICT, ACC_SUPER, ACC_SYNCHRONIZED, ACC_SYNTHETIC, ACC_TRANSIENT, ACC_VARARGS, ACC_VOLATILE, ACONST_NULL, ALOAD, ANEWARRAY, ARETURN, ARRAYLENGTH, ASM4, ASTORE, ATHROW, BALOAD, BASTORE, BIPUSH, CALOAD, CASTORE, CHECKCAST, D2F, D2I, D2L, DADD, DALOAD, DASTORE, DCMPG, DCMPL, DCONST_0, DCONST_1, DDIV, DLOAD, DMUL, DNEG, DOUBLE, DREM, DRETURN, DSTORE, DSUB, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, F_APPEND, F_CHOP, F_FULL, F_NEW, F_SAME, F_SAME1, F2D, F2I, F2L, FADD, FALOAD, FASTORE, FCMPG, FCMPL, FCONST_0, FCONST_1, FCONST_2, FDIV, FLOAD, FLOAT, FMUL, FNEG, FREM, FRETURN, FSTORE, FSUB, GETFIELD, GETSTATIC, GOTO, H_GETFIELD, H_GETSTATIC, H_INVOKEINTERFACE, H_INVOKESPECIAL, H_INVOKESTATIC, H_INVOKEVIRTUAL, H_NEWINVOKESPECIAL, H_PUTFIELD, H_PUTSTATIC, I2B, I2C, I2D, I2F, I2L, I2S, IADD, IALOAD, IAND, IASTORE, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, ICONST_M1, IDIV, IF_ACMPEQ, IF_ACMPNE, IF_ICMPEQ, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ICMPLT, IF_ICMPNE, IFEQ, IFGE, IFGT, IFLE, IFLT, IFNE, IFNONNULL, IFNULL, IINC, ILOAD, IMUL, INEG, INTEGER, INVOKEDYNAMIC, INVOKEINTERFACE, INVOKESPECIAL, INVOKESTATIC, INVOKEVIRTUAL, IOR, IREM, IRETURN, ISHL, ISHR, ISTORE, ISUB, IUSHR, IXOR, JSR, L2D, L2F, L2I, LADD, LALOAD, LAND, LASTORE, LCMP, LCONST_0, LCONST_1, LDC, LDIV, LLOAD, LMUL, LNEG, LONG, LOOKUPSWITCH, LOR, LREM, LRETURN, LSHL, LSHR, LSTORE, LSUB, LUSHR, LXOR, MONITORENTER, MONITOREXIT, MULTIANEWARRAY, NEW, NEWARRAY, NOP, NULL, POP, POP2, PUTFIELD, PUTSTATIC, RET, RETURN, SALOAD, SASTORE, SIPUSH, SWAP, T_BOOLEAN, T_BYTE, T_CHAR, T_DOUBLE, T_FLOAT, T_INT, T_LONG, T_SHORT, TABLESWITCH, TOP, UNINITIALIZED_THIS, V1_1, V1_2, V1_3, V1_4, V1_5, V1_6, V1_7`

### Constructor Summary

Constructors
Constructor and Description
`AbstractASTTransformUtil()`

### Method Summary

Methods
`static Statement` `assignStatement(Expression fieldExpr, Expression value)`
`static Statement` `createConstructorStatementDefault(FieldNode fNode)`
`static ExpressionStatement` `declStatement(Expression result, Expression init)`
`static BooleanExpression` `equalsNullExpr(Expression argExpr)`
`static Expression` `findArg(java.lang.String argName)`
`static java.util.List<FieldNode>` `getInstanceNonPropertyFields(ClassNode cNode)`
`static java.util.List<PropertyNode>` `getInstanceProperties(ClassNode cNode)`
`static java.util.List<FieldNode>` `getInstancePropertyFields(ClassNode cNode)`
`static java.util.List<FieldNode>` `getSuperNonPropertyFields(ClassNode cNode)`
`static java.util.List<FieldNode>` `getSuperPropertyFields(ClassNode cNode)`
`static boolean` `hasDeclaredMethod(ClassNode cNode, java.lang.String name, int argsCount)`
`static BooleanExpression` `isInstanceof(ClassNode cNode, Expression other)`
`static BooleanExpression` `isInstanceOf(Expression objectExpression, ClassNode cNode)`
`static BooleanExpression` `isOneExpr(Expression expr)`
`static boolean` `isOrImplements(ClassNode fieldType, ClassNode interfaceType)`
`static BooleanExpression` `isTrueExpr(Expression argExpr)`
`static BooleanExpression` `isZeroExpr(Expression expr)`
`static BooleanExpression` `notNullExpr(Expression argExpr)`
`static Statement` `returnFalseIfFieldNotEqual(FieldNode fNode, Expression other)`
`static Statement` `returnFalseIfNotInstanceof(ClassNode cNode, Expression other)`
`static IfStatement` `returnFalseIfNull(Expression other)`
`static Statement` `returnFalseIfPropertyNotEqual(FieldNode fNode, Expression other)` Deprecated.
`static Statement` `returnFalseIfPropertyNotEqual(PropertyNode pNode, Expression other)`
`static Statement` `returnFalseIfWrongType(ClassNode cNode, Expression other)`
`static IfStatement` `returnTrueIfIdentical(Expression self, Expression other)`
`static Statement` `safeExpression(Expression fieldExpr, Expression expression)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AbstractASTTransformUtil

    public AbstractASTTransformUtil()

### Method Detail

#### hasDeclaredMethod

    public static boolean hasDeclaredMethod(ClassNode cNode,
                            java.lang.String name,
                            int argsCount)

#### returnFalseIfWrongType

    public static Statement returnFalseIfWrongType(ClassNode cNode,
                                   Expression other)

#### returnFalseIfNotInstanceof

    public static Statement returnFalseIfNotInstanceof(ClassNode cNode,
                                       Expression other)

#### returnFalseIfNull

    public static IfStatement returnFalseIfNull(Expression other)

#### returnTrueIfIdentical

    public static IfStatement returnTrueIfIdentical(Expression self,
                                    Expression other)

#### returnFalseIfPropertyNotEqual

    @Deprecated
    public static Statement returnFalseIfPropertyNotEqual(FieldNode fNode,
                                                     Expression other)

Deprecated.

#### returnFalseIfPropertyNotEqual

    public static Statement returnFalseIfPropertyNotEqual(PropertyNode pNode,
                                          Expression other)

#### returnFalseIfFieldNotEqual

    public static Statement returnFalseIfFieldNotEqual(FieldNode fNode,
                                       Expression other)

#### getInstanceProperties

    public static java.util.List<PropertyNode> getInstanceProperties(ClassNode cNode)

#### getInstancePropertyFields

    public static java.util.List<FieldNode> getInstancePropertyFields(ClassNode cNode)

#### getInstanceNonPropertyFields

    public static java.util.List<FieldNode> getInstanceNonPropertyFields(ClassNode cNode)

#### getSuperPropertyFields

    public static java.util.List<FieldNode> getSuperPropertyFields(ClassNode cNode)

#### getSuperNonPropertyFields

    public static java.util.List<FieldNode> getSuperNonPropertyFields(ClassNode cNode)

#### assignStatement

    public static Statement assignStatement(Expression fieldExpr,
                            Expression value)

#### declStatement

    public static ExpressionStatement declStatement(Expression result,
                                    Expression init)

#### isInstanceOf

    public static BooleanExpression isInstanceOf(Expression objectExpression,
                                 ClassNode cNode)

#### equalsNullExpr

    public static BooleanExpression equalsNullExpr(Expression argExpr)

#### notNullExpr

    public static BooleanExpression notNullExpr(Expression argExpr)

#### isZeroExpr

    public static BooleanExpression isZeroExpr(Expression expr)

#### isInstanceof

    public static BooleanExpression isInstanceof(ClassNode cNode,
                                 Expression other)

#### isOrImplements

    public static boolean isOrImplements(ClassNode fieldType,
                         ClassNode interfaceType)

#### isTrueExpr

    public static BooleanExpression isTrueExpr(Expression argExpr)

#### isOneExpr

    public static BooleanExpression isOneExpr(Expression expr)

#### safeExpression

    public static Statement safeExpression(Expression fieldExpr,
                           Expression expression)

#### createConstructorStatementDefault

    public static Statement createConstructorStatementDefault(FieldNode fNode)

#### findArg

    public static Expression findArg(java.lang.String argName)